import Group
import string

#----------------------------------------------------------------------
# FormElement class
#----------------------------------------------------------------------

class FormElement(Group.Group):
  def __init__(self):
    Group.Group.__init__(self)
    self._target = None
    self._setter = None
    self._value = ""
    self._didChange = 0
    self._isEditable = 1
    self._hasError = 0
    self._errorMessage = ""

  def isFormElement(self): return 1

  def target(self): return self._target
  def target_(self, o): self._target = o; return self

  def setter(self):
    if not self._setter: return self.name() + "_"
    return self._setter
  def setter_(self, o): self._setter = o; return self

  def didChange(self): return self._didChange
  def didChange_(self, o): self._didChange = o; return self

  def isEditable(self): return self._isEditable
  def isEditable_(self, o): self._isEditable = o; return self

  def hasError(self): return self._hasError
  def hasError_(self, o): self._hasError = o; return self

  def errorMessage(self): return self._errorMessage
  def errorMessage_(self, o): 
    self._errorMessage = o; 
    if o: self.hasError_(1)
    return self

  def formName(self): return self.name()

  def value(self): return self._value

  def value_(self, value):
   self._value = value
   return self

  def inputValue_(self, value):
   value = self.convertedValueForInput(value)
   if self.target() and self.isEditable() and value != self._value:
     #log("changing value from " + repr(self._value) + " to: " + repr(value))
     self.target().perform_with_(self.setter(), value)
     self.didChange_(1)
   self.value_(value)
   return self

  def convertedValueForInput(self, value):
    return value

  def outputValue(self):
    return self.value()

  # --- rendering -------------------------------------

  def htmlContent(self):
    "This prevents a editable form element from being displayed if it is uneditable. Some subclasses will need to override this."
    if not self.isEditable():
      html = self.membersHtml()
      if string.find(html, '<') == -1:
        return string.replace(html, '\n', '<BR>')
      return html
    return Group.Group.htmlContent(self)

