
import FormElement

class Input(FormElement.FormElement):
  def __init__(self, *args, **kw):
    FormElement.FormElement.__init__(self)
    self.tagName_("input")
    self.setAttributeName_value_("type", "text")
    self.setAttributeName_value_("name", None)
    self.setAttributeName_value_("value", None)
    self.setAttributeName_value_("src", None)
    self.setAttributeName_value_("border", None)
    self.setAttributeName_value_("size", None)
    self.setAttributeName_value_("checked", None).showsValue_(0)
    self.keywords_(kw)

  def type_(self, o): self.set_value_("type", o); return self
  def type(self): return self.attributeNamed_("type").value()

  def name_(self, o): self.set_value_("name", o); return self
  def name(self): return self.attributeNamed_("name").value()

  def value_(self, o): self.set_value_("value", o); return self
  def value(self): return self.attributeNamed_("value").value()

  def src_(self, o): self.set_value_("src", o); return self
  def src(self): return self.attributeNamed_("src").value()

  def border_(self, o): self.set_value_("border", o); return self
  def border(self): return self.attributeNamed_("border").value()

  def size_(self, o): self.set_value_("size", o); return self
  def size(self): return self.attributeNamed_("size").value()

  def htmlContent(self):
    if not self.isEditable(): return str(self.value())
    return FormElement.FormElement.htmlContent(self)

  def endTag(self):
    if self.type() in [None, "text", "hidden","password","submit", "image"]: return ""
    return FormElement.FormElement.endTag(self)
