
import Table
import Row
import Column
import TableHeader
from log import *

class MenuTable(Table.Table):
  def __init__(self, *args, **kw):
    Table.Table.__init__(self)
    self.keywords_(kw)

    self._headerProto = TableHeader.TableHeader(width="1%")
    self._rowProto    = Row.Row()
    self._columnProto = Column.Column(width="1%")
    self._headerRow   = Row.Row()
    self._rows        = []
    self.append(self.headerRow())

  # --- headers -----------------------------------

  def headerRow_(self, o): self._headerRow = o; return self
  def headerRow(self): return self._headerRow

  def headers_(self, o): self.headerRow().members_(o); return self
  def headers(self): return self.headerRow().members()

  def addHeader_(self, tableHeader):
    self.headers().append(tableHeader)
    return self

  def removeHeader_(self, tableHeader):
    self.headers().remove(tableHeader)
    return self

  def headerNamed_(self, name):
    for header in self.headers():
      if header.membersHtml() == name: return header
    return None

  def headerNumber_(self, num):
    try:
      return self.headers()[num]
    except:
      return None

  # --- prototypes -----------------------------------

  def headerProto_(self, o): self._headerProto = o; return self
  def headerProto(self): return self._headerProto

  def rowProto_(self, o): self._rowProto = o; return self
  def rowProto(self): return self._rowProto

  def columnProto_(self, o): self._columnProto = o; return self
  def columnProto(self): return self._columnProto

  def newHeader(self): return self.headerProto().clone()

  # --- rows ------------------------------------------

  def rows_(self, o): self._rows = o; return self
  def rows(self): return self._rows

  def addRow_(self, row):
    self.rows().append(row)

  def newRow(self):    
    row = self.rowProto().clone()
    row.columnProto_(self.columnProto())
    self.rows().append(row)
    return row
    
  # --- body -----------------------------------

  def heading_(self, heading):
    for name in heading:
      header = self.newHeader()
      header.append(name)
      self.addHeader_(header)
    return self

  def body_(self, body):
    firstHeader = self.headerNumber_(0)
    if firstHeader: firstHeader.width_("1%")
    Table.Table.body_(self, body)

  # --- utility methods -----------------------------------

  def prepareToRender(self):
    self.append(self.headerRow())
    self.addMembers_(self.rows())
