
import PageGroup
import Body
import Header
import Title
import Style

class Page(PageGroup.PageGroup):
  def __init__(self, *args, **kw):
    PageGroup.PageGroup.__init__(self)
    self.tagName_("html")
    self._header = Header.Header()
    self._titleObject = Title.Title()
    self._style = Style.Style()
    self._header.append(self._style)
    self._body   = Body.Body(bgcolor="white", text="black")
    self._body.append(self._titleObject)
    self._stdout = None
    self.arguments_(args)
    self.keywords_(kw)

  def header_(self, o): self._header = o; return self
  def header(self): return self._header

  def body_(self, o): self._body = o; return self
  def body(self): return self._body

  def stdout_(self, o): self._stdout = o; return self
  def stdout(self): return self._stdout

  def title_(self, o): self._titleObject.members_([o]); return self
  def title(self): return self._titleObject.membersHtml()

  def style_(self, o): self._style = o; return self
  def style(self): return self._style

  def htmlContent(self):
    self.members_([self.header(), self.body()])
    return PageGroup.PageGroup.htmlContent(self)
 
  def append(self, o):
    self.body().append(o)
    return self

  def writeTo_(self, file):
    self.writeContentTypeTo_(file)
    PageGroup.PageGroup.writeTo_(self, file)
    return self

  def write(self):
    self.writeTo_(self.stdout())
    return self

  
  # --- processing forms -----------------------------

  def formElements(self):
    return self.membersWith_equalTo_("isFormElement", 1)

  def setFormValuesFromDict_(self, dict):
    elements = self.formElements()

    for element in elements:
      if element.respondsTo_("formName"):
        #log("element " + element.name())
        #log("dict.keys() = " + repr(dict.keys()))
        value = dict.get(element.formName(), "")
        #------------------------------------------------------
        # Note, html forms don't submit a field value if it is empty,
        # so we assume it's empty if we don't see it - ack!
        # This forces us to check whether the form is being submitted
        # by looking for any form variables. But this is not foolproof -
        # we could have a form that is completely empty with no
        # hidden variables, though this is very unlikely - SLD
        #-------------------------------------------------------
        #if value and element.respondsTo_("inputValue_"): 
        if element.respondsTo_("inputValue_"): 
          log("setting " + element.formName() + " = " + repr(value)) 
          element.inputValue_(value)

