
import Group
import Row
import Column

class Table(Group.Group):
  def __init__(self, *args, **kw):
    Group.Group.__init__(self)
    self.tagName_("table")
    self.setAttributeName_value_("border", 0)
    self.setAttributeName_value_("cellpadding", 3)
    self.setAttributeName_value_("cellspacing", 1)
    self.setAttributeName_value_("width", "100%")
    self.setAttributeName_value_("bgcolor", None)
    self.keywords_(kw)
  
  def border_(self, o): self.set_value_("border", o); return self
  def border(self): return self.attributeNamed_("border").value()

  def cellpadding_(self, o): self.set_value_("cellpadding", o); return self
  def cellpadding(self): return self.attributeNamed_("cellpadding").value()

  def cellspacing_(self, o): self.set_value_("cellspacing", o); return self
  def cellspacing(self): return self.attributeNamed_("cellspacing").value()

  def width_(self, o): self.set_value_("width", o); return self
  def width(self): return self.attributeNamed_("width").value()

  def bgcolor_(self, o): self.set_value_("bgcolor", o); return self
  def bgcolor(self): return self.attributeNamed_("bgcolor").value()

  # --- utility methods ---

  def newRow(self):
    row = Row.Row()
    self.append(row) 
    return row

  def removeRow_(self, row): return self.removeMember_(row)

  def body_(self, body):
    if not len(body): return 
    numberOfColumns = len(body[0])
    for rowNum in range(0, len(body)):
      numberOfColumnsInRow = len(body[rowNum])
      #if numberOfColumns != len(body[rowNum]):
      #  raise "Error: Wrong number of columns in row #%d: %s" % (rowNum, repr(body[rowNum]))
      row = self.newRow()
      for columnNum in range(0, numberOfColumnsInRow):
        column = row.newColumn()
        content = str(body[rowNum][columnNum]) 
        column.append(content)
        if not content: column.append("&nbsp;")
      if numberOfColumnsInRow < numberOfColumns:
        column.colspan_(numberOfColumns - numberOfColumnsInRow + 1)
        column.bgcolor_(None)

  def makeColumnsPerform_with_(self, method, argument):
    for column in self.allColumns():
      column.perform_with_(method, argument)

  def allColumns(self):
    columns = []
    for row in self.rows():
      columns = columns + row.columns()
    return columns

  def rows(self):
    return self.membersWithTag_("tr")

  def elementsInColumnNumber_(self, num):
    elements = []
    for row in self.rows():
      try:
        elements.append(row.columnNumber_(num))
      except AttributeError:
        pass
    return elements

  def rowNumber_(self, rowNum):
    return self.rows()[rowNum]

  def columnsInRowNumber_(self, rowNum):
    return self.rowNumber_(rowNum).columns()
